<?php
class EmailNotification {
	/**
	 * Get all the notifications for the email address specified
	 * Misnomer - Really a collection ...
	 * @success 200 Returns a list of people whose absences should be notified to the person identified by the resource
	 * @format application/json
	 * @example 
	 * [
	 *    "email"
	 * ]
	 */
	function onRetrieve () {
		$email = zget('/request/params/emailnotificationId');
		$dm = data_manager('hallmondb');
		$notifiers = data_exec($dm, "SELECT absent_person FROM notifications where notified_person = ?", array($email));
		//convert to appropriate form
		$notifierscopy = array();
		foreach($notifiers as $notifier) {
			$notifierscopy[] = $notifier['absent_person'];
		}	
		zput ('/request/headers/out/Content-Type', 'text/json');
		echo json_encode($notifierscopy);
		
	}
	
	/**
	 * Create a new notification for the person identified by the email address
	 * @success 200 notification is created
	 * @error 400 problem with data supplied
	 */
	function onPostMember() {
		$for_email = zget('/request/params/emailnotificationId');
		$absentee = json_decode($HTTP_RAW_POST_DATA);
		$dm = data_manager('hallmondb');
		$result = data_exec($dm, 'INSERT INTO notifications (notified_person, absent_person) '.
				'VALUES (?, ?)', 
				array($for_email, $absentee['email']));	

		if ($result == 1) {
			$locationUri = zget("/request/path") . "/" . $absentee["email"];
			zput("/request/headers/out/Location", $locationUri);
			zput("/request/status", 200);
		} else {
			echo "Problem with data/application";
			zput('/request/status', 400);
		}
	}
	
	/**
	 * Delete a specific notification
	 * @success 200 deleted specified notification
	 * @error 400 problem with supplied data
	 */
	function onDelete() {
		$for_email = zget('/request/params/emailnotificationId');
		// strip leading slash
		$absentee = substr(zget('/event/pathInfo'), 1);
		$dm = data_manager('hallmondb');

		// Delete notification for this pair 
		$result = data_exec($dm, "DELETE FROM notifications WHERE notified_person = ? AND absent_person = ?",
			array($for_email, $absentee));

		if ($result == 1) {
			zput("/request/status", 200);
		} else {
			zput("/request/status", 400);
		}
	}
	
}
?>
