<?php
class TeamNotification {
	/**
	 * Get all the notifications for the email address specified
	 * Misnomer - Really a collection ...
	 * @success 200 A list of team notifications for a person
	 * @format text/json
	 * @example 
	 * [
	 *     "team1",
	 *     "team2"
	 * ]
	 *    
	 */
	function onRetrieve () {
		$email = zget('/request/params/teamnotificationId');
		$dm = data_manager('hallmondb');
		$notifiers = data_exec($dm, "SELECT team_name FROM teamnotifications where notified_person = ?", array($email));
		//convert to appropriate form
		$notifierscopy = array();
		foreach($notifiers as $notifier) {
			$notifierscopy[] = $notifier['teamname'];
		}	
		zput ('/request/headers/out/Content-Type', 'text/json');
		echo json_encode($notifierscopy);
		
	}
	
	/**
	 * Create a new notification for the person identified by the email address
	 * @success 200 notification created for person
	 * @error 400 Problem with data or application
	 * @format text/json
	 * @example 
	 * {
	 *    "teamname":"team20"
	 * }
	 */
	function onPostMember() {
		$defaultOrg = 'Zero';
		$for_email = zget('/request/params/teamnotificationId');
		$team = json_decode($HTTP_RAW_POST_DATA);
		$dm = data_manager('hallmondb');
		$result = data_exec($dm, 'INSERT INTO teamnotifications (notified_person, team_name, org_name) '.
				'VALUES (?, ?, ?)', 
				array($for_email, $team['teamname'], $defaultOrg));	

		if ($result == 1) {
			$locationUri = zget("/request/path") . "/" . $team["teamname"];
			zput("/request/headers/out/Location", $locationUri);
			zput("/request/status", 200);
		} else {
			echo "Problem with data/application";
			zput('/request/status', 400);
		}
	}
	
	/**
	 * Delete a specific notification
	 * @success 200 notification deleted
	 * @error 400 notification not found
	 */
	function onDelete() {
		$defaultOrg = 'Zero';
		$for_email = zget('/request/params/teamnotificationId');
		// TODO: Does not really map well to what I had in mind
		// strip leading /
		$teamname = substr(zget('/event/pathInfo'), 1);
		// TODO: Strip leading slash out ouf team name ?
		$dm = data_manager('hallmondb');

		// Delete notification for this pair 
		$result = data_exec($dm, "DELETE FROM teamnotifications WHERE notified_person = ? AND team_name = ?",
			array($for_email, $teamname));
			
		if ($result == 1) {
			zput("/request/status", 200);
		} else {
			zput("/request/status", 400);
		}
	}
}
?>
