<?php
	/**
	 * function for validating input
	 */
	function validate_input($data, $validators) {
		global $errormsg;
		$invalid = false;
		foreach ($validators as $v) {
			if (!isset($data[$v]) || $data[$v] == "") {
				echo "Invalid data: $v not set\n";
				$errormsg += "Invalid data: $v not set\n";
				$invalid = true;
			}
		}
		return $invalid;
	}

	/**
	 * Function for generating a text message for not being in the office
	 */
	function expand_reason($reason) {
		$ret = "";
		switch($reason) {
			case 'wah':
				$ret = "Working at home";
				break;
			case 'pb':
				$ret = "Away on personal business";
				break;
			case 'class':
				$ret = "In a class, conference or meeting";
				break;
			case 'sick':
				$ret = "Not at work (sick)";
				break;
			case 'back':
				$ret = "Back in the office";
				break;
			case 'vacation':
				$ret = "Away on vacation";
				break;
		}
		return $ret;
	}
	
	/**
	 * Function for generating a text message for a range of dates including AM/PM
	 */
	function expand_dates($startdate, $enddate, $tod) {
		$timestring = "";
		if ($tod == 'AM') {
			$timestring = " in the morning"; 
		} else if ($tod == 'PM') {
			$timestring = " in the evening";
		} 
		if ($startdate == $enddate) {
			$range_string = "on $startdate";
		} else {
			$range_string = "from $startdate to $enddate";
		}
		$retstring = $range_string.$timestring;
		return $retstring;
		
	}
	
    /**
     * Function for returning derived email notifications for an absence
     */
    function get_derived_notifications($absentee) {
        $dm = data_manager('hallmondb');

        // Long SQL statement follows.
        $sql = "select distinct notified_person as np from (select name as team_belonged from teammembers where member_email = ? ) as teamsbelongedto join teamnotifications on teamnotifications.team_name = teamsbelongedto.team_belonged union select notified_person as np from notifications where absent_person = ? ";
        $result = data_exec($dm, $sql, array($absentee, $absentee));
        $emails = array();
        foreach ($result as $row) {
            foreach ($row as $name => $value) {
                 $emails[] = $value;
  	        }
        }
        return($emails);
    }

   /**
     * Function for sending email notifications for an absence
     */
    function send_notifications($absentee, $summary, $message) {
        $dm = data_manager('hallmondb');
        $result = data_exec($dm, "select name from people where email = ?", array($absentee));
        $messagetxt = trim($result[0]['name'])." will be ".strtolower(substr($summary, 0, 1)).substr($summary, 1);
        $full_message = <<<MSG
$message
This is an autogenerated message.
        
- Office Monitor
http://zero.webahead.ibm.com:8080/officemon/
MSG;

        // Long SQL statement follows.
        $sql = "select distinct notified_person as np from (select name as team_belonged from teammembers where member_email = ? ) as teamsbelongedto join teamnotifications on teamnotifications.team_name = teamsbelongedto.team_belonged union select notified_person as np from notifications where absent_person = ? ";
        $result = data_exec($dm, $sql, array($absentee, $absentee));
	if (is_array($result) && count($result) > 0) {
	        $ec = new Java("zero.core.connection.EmailConnection", $result[0]['np']);
       		array_shift($result);
        	foreach ($result as $row) {
               		foreach($row as $name => $email) {
               			$ec->addRecipient($email);
               		}
        	}
		$ec->setFromAddress("officemon@projectzero.org");
		$ec->setSubject($messagetxt);
		$ec->setContent($full_message);
		$ec->send();
	}
        return;
    }
?>
